## csound 5.08.0.dfsg2

=== SConstruct ===
#J vim:syntax=python
print '''
C S O U N D 5

SCons build file for Csound 5:
API library, plugin opcodes, utilities, and front ends.

By Michael Gogins <gogins at pipeline dot com>

For custom options, run 'scons -h'.
For default options, run 'scons -H'.
If headers or libraries are not found, edit 'custom.py'.
For Linux, run in the standard shell
    with standard Python and just run 'scons'.
For MinGW, run in the MSys shell
    and use www.python.org WIN32 Python to run scons.
For Microsoft Visual C++, run in the Platform SDK
    command shell, and use www.python.org WIN32 Python to run scons.
'''

import time
import glob
import os
import os.path
import sys
import string
import zipfile
import shutil
import copy

#############################################################################
#
#   UTILITY FUNCTIONS
#############################################################################

zipDependencies = []
pluginLibraries = []
executables = []
headers = Split('''
    H/cfgvar.h H/cscore.h H/csdl.h H/csound.h H/csound.hpp H/csoundCore.h
    H/cwindow.h H/msg_attr.h H/OpcodeBase.hpp H/pstream.h H/pvfileio.h
    H/soundio.h H/sysdep.h H/text.h H/version.h
    interfaces/CsoundFile.hpp interfaces/CppSound.hpp interfaces/filebuilding.h
''')
libs = []
pythonModules = []

def today():
    return time.strftime("%Y-%m-%d", time.localtime())

# Detect OPERATING SYSTEM platform.

def getPlatform():
    if sys.platform[:5] == 'linux':
        return 'linux'
    elif sys.platform[:3] == 'win':
        return 'win32'
    elif sys.platform[:6] == 'darwin':
        return 'darwin'
    else:
        return 'unsupported'

#############################################################################
#
#   DEFINE CONFIGURATION
#
#############################################################################

print "System platform is '" + getPlatform() + "'."

# Create options that can be set from the command line.

commandOptions = Options()
commandOptions.Add('CC')
commandOptions.Add('CXX')
commandOptions.Add('LINK')
commandOptions.Add('LINKFLAGS')
commandOptions.Add('custom',
    'Specify name of custom options file (default is "custom.py")',
    'custom.py')
commandOptions.Add('useDouble',
    'Set to 1 to use double-precision floating point for audio samples.',
    '0')
commandOptions.Add('usePortAudio',
    'Set to 1 to use PortAudio for real-time audio input and output.',
    '1')
commandOptions.Add('usePortMIDI',
    'Build PortMidi plugin for real time MIDI input and output.',
    '1')
commandOptions.Add('useALSA',
    'Set to 1 to use ALSA for real-time audio and MIDI input and output.',
    '1')
commandOptions.Add('useJack',
    'Set to 1 if you compiled PortAudio to use Jack; also builds Jack plugin.',
    '1')
commandOptions.Add('useFLTK',
    'Set to 1 to use FLTK for graphs and widget opcodes.',
    '1')
commandOptions.Add('noFLTKThreads',
    'Set to 1 to disable use of a separate thread for FLTK widgets.',
    '1')
commandOptions.Add('pythonVersion',
    'Set to the Python version to be used.',
    '%d.%d' % (int(sys.hexversion) >> 24, (int(sys.hexversion) >> 16) & 255))
commandOptions.Add('buildCsoundVST',
    'Set to 1 to build CsoundVST (needs CsoundAC, FLTK, boost, Python, SWIG).',
    '0')
commandOptions.Add('buildCsoundAC',
    'Set to 1 to build CsoundAC (needs FLTK, boost, Python, SWIG).',
    '0')
commandOptions.Add('buildCsound5GUI',
    'Build FLTK GUI frontend (requires FLTK 1.1.7 or later).',
    '0')
commandOptions.Add('generateTags',
    'Set to 1 to generate TAGS',
    '0')
commandOptions.Add('generatePdf',
    'Set to 1 to generate PDF documentation',
    '0')
commandOptions.Add('generateZip',
    'Set to 1 to generate zip archive',
    '0')
commandOptions.Add('buildLoris',
    'Set to 1 to build the Loris Python extension and opcodes',
    '1')
commandOptions.Add('useOSC',
    'Set to 1 if you want OSC support',
    '0')
if getPlatform() != 'win32':
    commandOptions.Add('useUDP',
        'Set to 0 if you do not want UDP support',
        '1')
else:
    commandOptions.Add('useUDP',
        'Set to 1 if you want UDP support',
        '0')
commandOptions.Add('buildPythonOpcodes',
    'Set to 1 to build Python opcodes',
    '0')
commandOptions.Add('prefix',
    'Base directory for installs. Defaults to /usr/local.',
    '/usr/local')
commandOptions.Add('buildRelease',
    'Set to 1 to build for release (implies noDebug).',
    '0')
commandOptions.Add('noDebug',
    'Build without debugging information.',
    '0')
commandOptions.Add('gcc3opt',
    'Enable gcc 3.3.x or later optimizations for the specified CPU architecture (e.g. pentium3); implies noDebug.',
    '0')
commandOptions.Add('gcc4opt',
    'Enable gcc 4.0 or later optimizations for the specified CPU architecture (e.g. pentium3); implies noDebug.',
    '0')
commandOptions.Add('useLrint',
    'Use lrint() and lrintf() for converting floating point values to integers.',
    '0')
commandOptions.Add('useGprof',
    'Build with profiling information (-pg).',
    '0')
commandOptions.Add('Word64',
    'Build for 64bit computer',
    '0')
commandOptions.Add('Lib64',
    'Build for lib64 rather than lib',
    '0')
if getPlatform() == 'win32':
    commandOptions.Add('dynamicCsoundLibrary',
        'Set to 0 to build static Csound library instead of csound.dll',
        '1')
else:
    commandOptions.Add('dynamicCsoundLibrary',
        'Build dynamic Csound library instead of libcsound.a',
        '0')
commandOptions.Add('buildStkOpcodes',
    "Build opcodes encapsulating Perry Cook's Synthesis Toolkit in C++ instruments and effects",
    '0')
commandOptions.Add('install',
    'Enables the Install targets',
    '0')
commandOptions.Add('buildPDClass',
    "build csoundapi~ PD class (needs m_pd.h in the standard places)",
    '0')
commandOptions.Add('useCoreAudio',
    "Set to 1 to use CoreAudio for real-time audio input and output.",
    '1')
commandOptions.Add('useAltivec',
    "On OSX use the gcc AltiVec optmisation flags",
    '0')
commandOptions.Add('buildDSSI',
    "Build DSSI/LADSPA host opcodes",
    '1')
commandOptions.Add('buildUtilities',
    "Build stand-alone executables for utilities that can also be used with -U",
    '1')
commandOptions.Add('buildTclcsound',
    "Build Tclcsound frontend (cstclsh, cswish and tclcsound dynamic module). Requires Tcl/Tk headers and libs",
    '0')
commandOptions.Add('buildWinsound',
    "Build Winsound frontend. Requires FLTK headers and libs",
    '0')
commandOptions.Add('buildVirtual',
    "Build Virtual MIDI keyboard. Requires FLTK 1.1.7 or later headers and libs",
    '0')
commandOptions.Add('buildInterfaces',
    "Build interface library for Python, JAVA, Lua, C++, and other languages.",
    '0')
commandOptions.Add('buildJavaWrapper',
    'Set to 1 to build Java wrapper for the interface library.',
    '0')
commandOptions.Add('buildOSXGUI',
    'On OSX, set to 1 to build the basic GUI frontend',
    '0')
commandOptions.Add('buildCSEditor',
    'Set to 1 to build the Csound syntax highlighting text editor. Requires FLTK headers and libs',
    '0')
commandOptions.Add('withICL',
    'On Windows, set to 1 to build with the Intel C++ Compiler (also requires Microsoft Visual C++), or set to 0 to build with MinGW',
    '0')
commandOptions.Add('withMSVC',
    'On Windows, set to 1 to build with Microsoft Visual C++, or set to 0 to build with MinGW',
    '0')
commandOptions.Add('buildNewParser',
    'Enable building new parser (requires Flex/Bison)',
    '0')
commandOptions.Add('buildvst4cs',
    'Set to 1 to build vst4cs plugins (requires Steinberg VST headers)',
    '0')
commandOptions.Add('buildSDFT',
    'Set to 0 to avoid building SDFT code',
    '1')
commandOptions.Add('useGettext',
    'Set to 1 to use the GBU internationalisation/localisation scheme)',
    '0')
commandOptions.Add('buildImageOpcodes',
    'Set to 0 to avoid building image opcodes',
    '1')

# Define the common part of the build environment.
# This section also sets up customized options for third-party libraries, which
# should take priority over default options.

commonEnvironment = Environment(ENV = {'PATH' : os.environ['PATH']})
commandOptions.Update(commonEnvironment)

def compilerIntel():
    if getPlatform() == 'win32' and commonEnvironment['withICL'] == '1':
        return True
    else:
        return False

def compilerMicrosoft():
    if getPlatform() == 'win32' and commonEnvironment['withMSVC'] == '1':
        return True
    else:
        return False

def compilerGNU():
    if not compilerIntel() and not compilerMicrosoft():
        return True
    else:
        return False

optionsFilename = 'custom.py'

if compilerIntel():
	print 'Importing complete environment for the Intel C++ Compiler (ICL)...'
	commonEnvironment = Environment(ENV = os.environ)
	commandOptions.Update(commonEnvironment)
	Tool('icl')(commonEnvironment)
	optionsFilename = 'custom-msvc.py'
elif compilerMicrosoft():
	# To enable the Microsoft tools, 
	# the WHOLE environment must be imported,
	# not just the PATH; so we replace the 
	# enviroment with a more complete one.
	print 'Importing complete environment for Microsoft Visual C++ (MSVC)...'
	commonEnvironment = Environment(ENV = os.environ)
	commandOptions.Update(commonEnvironment)
	optionsFilename = 'custom-msvc.py'
elif getPlatform() == 'win32':
        # Similarly, on Windows, to exclude MSVC tools,
	# we have to force MinGW tools and then re-create
	# the environment from scratch.
	commonEnvironment = Environment(ENV = os.environ, tools = ['mingw', 'swig', 'javac', 'jar'])
	commandOptions.Update(commonEnvironment)
	#Tool('mingw')(commonEnvironment)
	optionsFilename = 'custom-mingw.py'

Help(commandOptions.GenerateHelpText(commonEnvironment))

if commonEnvironment['custom']:
    optionsFilename = commonEnvironment['custom']

print "Using options from '%s.'" % optionsFilename

fileOptions = Options(optionsFilename)
fileOptions.Add('customCPPPATH', 'List of custom CPPPATH variables')
fileOptions.Add('customCCFLAGS')
fileOptions.Add('customCXXFLAGS')
fileOptions.Add('customLIBS')
fileOptions.Add('customLIBPATH')
fileOptions.Add('customSHLINKFLAGS')
fileOptions.Add('customSWIGFLAGS')
fileOptions.Update(commonEnvironment)

customCPPPATH = commonEnvironment['customCPPPATH']
commonEnvironment.Prepend(CPPPATH = customCPPPATH)
customCCFLAGS = commonEnvironment['customCCFLAGS']
commonEnvironment.Prepend(CCFLAGS = customCCFLAGS)
customCXXFLAGS = commonEnvironment['customCXXFLAGS']
commonEnvironment.Prepend(CXXFLAGS = customCXXFLAGS)
customLIBS = commonEnvironment['customLIBS']
commonEnvironment.Prepend(LIBS = customLIBS)
customLIBPATH = commonEnvironment['customLIBPATH']
commonEnvironment.Prepend(LIBPATH = customLIBPATH)
customSHLINKFLAGS = commonEnvironment['customSHLINKFLAGS']
commonEnvironment.Prepend(SHLINKFLAGS = customSHLINKFLAGS)
customSWIGFLAGS = commonEnvironment['customSWIGFLAGS']
commonEnvironment.Prepend(SWIGFLAGS = customSWIGFLAGS)

# Define options for different platforms.
if getPlatform() != 'win32':
    print "Build platform is '" + getPlatform() + "'."
else:
    if compilerMicrosoft():
        print "Build platform is Microsoft Visual C++ (MSVC)."
    elif compilerIntel():
        print "Build platform is the Intel C++ Compiler (ICL)."
    elif compilerGNU():
        print "Build platform is MinGW/MSYS"

print "SCons tools on this platform: ", commonEnvironment['TOOLS']

commonEnvironment.Prepend(CPPPATH = ['.', './H'])
if commonEnvironment['useLrint'] != '0':
    commonEnvironment.Prepend(CCFLAGS = ['-DUSE_LRINT'])
if commonEnvironment['useGettext'] != '0':
    print "Using GNU gettext scheme"
    commonEnvironment.Prepend(CCFLAGS = ['-DGNU_GETTEXT'])
    if getPlatform() == "win32":
        commonEnvironment.Append(LIBS=['intl'])
else:
    print "Using Istvan localisation"
    commonEnvironment.Prepend(CCFLAGS = ['-DNOGETTEXT'])
    
if commonEnvironment['gcc3opt'] != '0' or commonEnvironment['gcc4opt'] != '0':

=== installer/macosx/Makefile ===
installer: new_install.cxx installer.cxx installer.h
	c++ -g -o installer new_install.cxx -lfltk -lpthread  -framework Carbon -framework ApplicationServices -lsupc++

=== Opcodes/stk/src/Makefile ===
### libstk Makefile - for various flavors of unix

LIBRARY = libstk.a
AR = ar -rsc
RM = /bin/rm
OBJECT_PATH = Release
vpath %.o $(OBJECT_PATH)

OBJECTS	=	Stk.o Generator.o Noise.o SubNoise.o Blit.o BlitSaw.o BlitSquare.o \
					Envelope.o ADSR.o Asymp.o Modulate.o SingWave.o SineWave.o Granulate.o \
					FileRead.o FileWrite.o WvIn.o FileWvIn.o WaveLoop.o WvOut.o FileWvOut.o \
					Filter.o OneZero.o OnePole.o PoleZero.o TwoZero.o TwoPole.o \
					BiQuad.o FormSwep.o Delay.o DelayL.o DelayA.o \
					Effect.o PRCRev.o JCRev.o NRev.o \
					Chorus.o Echo.o PitShift.o \
					Function.o ReedTable.o JetTable.o BowTable.o \
					Voicer.o Vector3D.o Sphere.o \
					\
					Instrmnt.o Clarinet.o BlowHole.o Saxofony.o Flute.o Brass.o BlowBotl.o \
					Bowed.o Plucked.o StifKarp.o Sitar.o PluckTwo.o Mandolin.o Mesh2D.o \
					FM.o Rhodey.o Wurley.o TubeBell.o HevyMetl.o PercFlut.o BeeThree.o FMVoices.o \
					Sampler.o Moog.o Simple.o Drummer.o Shakers.o \
					Modal.o ModalBar.o BandedWG.o Resonate.o VoicForm.o Phonemes.o Whistle.o \
					\
					Messager.o Skini.o MidiFileIn.o


INCLUDE = $(HOME)/research/programming/stk-4.2.1/include/
ifeq ($(strip $(INCLUDE)),)
	vpath %.h ../include
	INCLUDE = -I../include
else
	vpath %.h ../include $(INCLUDE)
	INCLUDE = -I../include -I$(HOME)/research/programming/stk-4.2.1/include/
endif

CC       = g++
DEFS     = 
DEFS    += 
CFLAGS   = -O3
CFLAGS  += -Wall -g -D__GXX__ $(INCLUDE)

REALTIME = yes
ifeq ($(REALTIME),yes)
	OBJECTS += RtMidi.o RtAudio.o RtWvOut.o RtWvIn.o RtDuplex.o InetWvOut.o InetWvIn.o Thread.o Mutex.o Socket.o TcpClient.o TcpServer.o UdpSocket.o
	DEFS    += -D__MACOSX_CORE__
endif

RAWWAVES = $(HOME)/research/programming/stk-4.2.1/rawwaves/
ifeq ($(strip $(RAWWAVES)), )
	RAWWAVES = ../rawwaves/
endif
DEFS    += -DRAWWAVE_PATH=\"$(RAWWAVES)\"

%.o : %.cpp
	$(CC) $(CFLAGS) $(DEFS) -c $(<) -o $(OBJECT_PATH)/$@

all : $(LIBRARY)

$(LIBRARY) : $(OBJECTS)
	/bin/rm -f $(LIBRARY)
	$(AR) $(LIBRARY) $(OBJECT_PATH)/*.o

$(OBJECTS) : Stk.h

clean : 
	-rm $(OBJECT_PATH)/*.o
	-rm $(LIBRARY)

## csound 5.10.1~dfsg1

=== SConstruct ===
--- 
+++ 
@@ -24,7 +24,6 @@
 import os.path
 import sys
 import string
-import zipfile
 import shutil
 import copy
 
@@ -33,7 +32,6 @@
 #   UTILITY FUNCTIONS
 #############################################################################
 
-zipDependencies = []
 pluginLibraries = []
 executables = []
 headers = Split('''
@@ -117,14 +115,14 @@
 commandOptions.Add('generatePdf',
     'Set to 1 to generate PDF documentation',
     '0')
-commandOptions.Add('generateZip',
-    'Set to 1 to generate zip archive',
-    '0')
 commandOptions.Add('buildLoris',
     'Set to 1 to build the Loris Python extension and opcodes',
     '1')
 commandOptions.Add('useOSC',
     'Set to 1 if you want OSC support',
+    '0')
+commandOptions.Add('bufferoverflowu',
+    'Set to 1 to use the Windows buffer overflow library, required if you use MinGW to link with MSVC-built libraries',
     '0')
 if getPlatform() != 'win32':
     commandOptions.Add('useUDP',
@@ -140,6 +138,9 @@
 commandOptions.Add('prefix',
     'Base directory for installs. Defaults to /usr/local.',
     '/usr/local')
+commandOptions.Add('instdir',
+    'For the install target: puts instdir before the prefix',
+    '')
 commandOptions.Add('buildRelease',
     'Set to 1 to build for release (implies noDebug).',
     '0')
@@ -226,15 +227,23 @@
 commandOptions.Add('buildvst4cs',
     'Set to 1 to build vst4cs plugins (requires Steinberg VST headers)',
     '0')
-commandOptions.Add('buildSDFT',
-    'Set to 0 to avoid building SDFT code',
-    '1')
-commandOptions.Add('useGettext',
+if getPlatform() == 'win32':
+  commandOptions.Add('useGettext',
     'Set to 1 to use the GBU internationalisation/localisation scheme)',
     '0')
+else:
+  commandOptions.Add('useGettext',
+    'Set to 0 to use the Varga internationalisation/localisation scheme)', '1')
 commandOptions.Add('buildImageOpcodes',
     'Set to 0 to avoid building image opcodes',
     '1')
+##### JPff for OLPC #####
+commandOptions.Add('buildOLPC',
+    'Set to 1 to build OLPC version',
+    '0')
+commandOptions.Add('tclversion',
+    'Set to 8.4 or 8.5',
+    '8.4')
 
 # Define the common part of the build environment.
 # This section also sets up customized options for third-party libraries, which
@@ -319,29 +328,18 @@
 customSWIGFLAGS = commonEnvironment['customSWIGFLAGS']
 commonEnvironment.Prepend(SWIGFLAGS = customSWIGFLAGS)
 
-# Define options for different platforms.
-if getPlatform() != 'win32':
-    print "Build platform is '" + getPlatform() + "'."
-else:
-    if compilerMicrosoft():
-        print "Build platform is Microsoft Visual C++ (MSVC)."
-    elif compilerIntel():
-        print "Build platform is the Intel C++ Compiler (ICL)."
-    elif compilerGNU():
-        print "Build platform is MinGW/MSYS"
-
-print "SCons tools on this platform: ", commonEnvironment['TOOLS']
-
-commonEnvironment.Prepend(CPPPATH = ['.', './H'])
-if commonEnvironment['useLrint'] != '0':
-    commonEnvironment.Prepend(CCFLAGS = ['-DUSE_LRINT'])
-if commonEnvironment['useGettext'] != '0':
-    print "Using GNU gettext scheme"
-    commonEnvironment.Prepend(CCFLAGS = ['-DGNU_GETTEXT'])
-    if getPlatform() == "win32":
-        commonEnvironment.Append(LIBS=['intl'])
-else:
-    print "Using Istvan localisation"
-    commonEnvironment.Prepend(CCFLAGS = ['-DNOGETTEXT'])
-    
-if commonEnvironment['gcc3opt'] != '0' or commonEnvironment['gcc4opt'] != '0':
+if commonEnvironment['buildOLPC'] == '1':
+    commonEnvironment['pythonVersion'] = '2.5'
+    buildOLPC = True;
+    commonEnvironment.Prepend(CPPFLAGS = ['-DOLPC'])
+    commonEnvironment.Prepend(CPPFLAGS = ['-DENABLE_OPCODEDIR_WARNINGS=0'])
+    if getPlatform() != 'linux':
+       print "Build platform is not linux"
+    # Set other options??
+    commonEnvironment['useGettext'] = '1'
+    commonEnvironment['useDouble'] = '0'
+    commonEnvironment['usePortAudio'] = '0'
+    commonEnvironment['useJack'] = '1'
+    #jackFound = False
+    commonEnvironment['buildCsoundAC'] = '0'
+    commonEnvironment['buildCsound5GUI'] = '0'

=== examples/java/Makefile ===

all: CSDPlayer.jar CsoundEditor.jar

CSDPlayer.jar: CSDPlayer.java CSDPlayer.mf
	-rm *.class csnd/*
	-rmdir csnd
	javac -classpath ../../csnd.jar $<
	jar xf ../../csnd.jar csnd
	jar cfm $@ CSDPlayer.mf csnd *.class
	jar i $@
	-rm *.class csnd/*
	-rmdir csnd

CsoundEditor.jar: CsoundEditor.java CsoundEditor.mf
	-rm *.class csnd/*
	-rmdir csnd
	javac -classpath ../../csnd.jar $<
	jar xf ../../csnd.jar csnd
	jar cfm $@ CsoundEditor.mf csnd *.class
	jar i $@
	-rm *.class csnd/*
	-rmdir csnd

clean:
	-rm *.jar *.class csnd/*
	-rmdir csnd

## csound 5.12.1~dfsg

=== SConstruct ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #J vim:syntax=python
 print '''
-C S O U N D 5
+      C S O U N D 5
 
 SCons build file for Csound 5:
 API library, plugin opcodes, utilities, and front ends.
@@ -30,6 +30,7 @@
 #############################################################################
 #
 #   UTILITY FUNCTIONS
+#
 #############################################################################
 
 pluginLibraries = []
@@ -55,6 +56,8 @@
         return 'win32'
     elif sys.platform[:6] == 'darwin':
         return 'darwin'
+    elif sys.platform[:5] == 'sunos':
+        return 'sunos'    
     else:
         return 'unsupported'
 
@@ -204,10 +207,16 @@
     "Build Virtual MIDI keyboard. Requires FLTK 1.1.7 or later headers and libs",
     '0')
 commandOptions.Add('buildInterfaces',
-    "Build interface library for Python, JAVA, Lua, C++, and other languages.",
+    "Build C++ interface library.",
+    '0')
+commandOptions.Add('buildLuaWrapper',
+    'Set to 1 to build Lua wrapper for the C++ interface library (needs buildInterfaces).',
+    '0')
+commandOptions.Add('buildPythonWrapper',
+    'Set to 1 to build Python wrapper for the C++ interface library (needs buildInterfaces).',
     '0')
 commandOptions.Add('buildJavaWrapper',
-    'Set to 1 to build Java wrapper for the interface library.',
+    'Set to 1 to build Java wrapper for the C++ interface library (needs buildInterfaces).',
     '0')
 commandOptions.Add('buildOSXGUI',
     'On OSX, set to 1 to build the basic GUI frontend',
@@ -221,19 +230,26 @@
 commandOptions.Add('withMSVC',
     'On Windows, set to 1 to build with Microsoft Visual C++, or set to 0 to build with MinGW',
     '0')
+commandOptions.Add('withSunStudio',
+    'On Solaris, set to 1 to build with Sun Studio, or set to 0 to build with gcc',
+    '1')    
 commandOptions.Add('buildNewParser',
     'Enable building new parser (requires Flex/Bison)',
     '0')
+commandOptions.Add('NewParserDebug',
+    'Enable tracing of new parser',
+    '0')
 commandOptions.Add('buildvst4cs',
     'Set to 1 to build vst4cs plugins (requires Steinberg VST headers)',
     '0')
 if getPlatform() == 'win32':
   commandOptions.Add('useGettext',
-    'Set to 1 to use the GBU internationalisation/localisation scheme)',
+    'Set to 1 to use the GBU internationalisation/localisation scheme',
     '0')
 else:
   commandOptions.Add('useGettext',
-    'Set to 0 to use the Varga internationalisation/localisation scheme)', '1')
+    'Set to 0 for none and 1 for GNU internationalisation/localisation scheme',
+    '1')
 commandOptions.Add('buildImageOpcodes',
     'Set to 0 to avoid building image opcodes',
     '1')
@@ -244,12 +260,21 @@
 commandOptions.Add('tclversion',
     'Set to 8.4 or 8.5',
     '8.4')
+commandOptions.Add('includeMP3',
+     'Set to 1 if using mpadec', 
+     '0')
+commandOptions.Add('includeWii',
+     'Set to 1 if using libwiimote', 
+     '0')
+commandOptions.Add('includeP5Glove',
+     'Set to 1 if using P5 Glove', 
+     '0')
 
 # Define the common part of the build environment.
 # This section also sets up customized options for third-party libraries, which
 # should take priority over default options.
 
-commonEnvironment = Environment(ENV = {'PATH' : os.environ['PATH']})
+commonEnvironment = Environment(ENV = os.environ)
 commandOptions.Update(commonEnvironment)
 
 def compilerIntel():
@@ -263,9 +288,15 @@
         return True
     else:
         return False
+        
+def compilerSun():
+    if getPlatform() == 'sunos' and commonEnvironment['withSunStudio'] == '1':
+        return True
+    else:
+        return False        
 
 def compilerGNU():
-    if not compilerIntel() and not compilerMicrosoft():
+    if not compilerIntel() and not compilerMicrosoft() and not compilerSun():
         return True
     else:
         return False
@@ -273,22 +304,12 @@
 optionsFilename = 'custom.py'
 
 if compilerIntel():
-	print 'Importing complete environment for the Intel C++ Compiler (ICL)...'
-	commonEnvironment = Environment(ENV = os.environ)
-	commandOptions.Update(commonEnvironment)
 	Tool('icl')(commonEnvironment)
 	optionsFilename = 'custom-msvc.py'
 elif compilerMicrosoft():
-	# To enable the Microsoft tools, 
-	# the WHOLE environment must be imported,
-	# not just the PATH; so we replace the 
-	# enviroment with a more complete one.
-	print 'Importing complete environment for Microsoft Visual C++ (MSVC)...'
-	commonEnvironment = Environment(ENV = os.environ)
-	commandOptions.Update(commonEnvironment)
 	optionsFilename = 'custom-msvc.py'
 elif getPlatform() == 'win32':
-        # Similarly, on Windows, to exclude MSVC tools,
+	# On Windows, to exclude MSVC tools,
 	# we have to force MinGW tools and then re-create
 	# the environment from scratch.
 	commonEnvironment = Environment(ENV = os.environ, tools = ['mingw', 'swig', 'javac', 'jar'])
@@ -332,14 +353,3 @@
     commonEnvironment['pythonVersion'] = '2.5'
     buildOLPC = True;
     commonEnvironment.Prepend(CPPFLAGS = ['-DOLPC'])
-    commonEnvironment.Prepend(CPPFLAGS = ['-DENABLE_OPCODEDIR_WARNINGS=0'])
-    if getPlatform() != 'linux':
-       print "Build platform is not linux"
-    # Set other options??
-    commonEnvironment['useGettext'] = '1'
-    commonEnvironment['useDouble'] = '0'
-    commonEnvironment['usePortAudio'] = '0'
-    commonEnvironment['useJack'] = '1'
-    #jackFound = False
-    commonEnvironment['buildCsoundAC'] = '0'
-    commonEnvironment['buildCsound5GUI'] = '0'

=== examples/java/Makefile ===

all: CSDPlayer.jar CsoundEditor.jar

CSDPlayer.jar: CSDPlayer.java CSDPlayer.mf
	-rm *.class csnd/*
	-rmdir csnd
	javac -classpath ../../bin/csnd.jar $<
	jar xf ../../bin/csnd.jar csnd
	jar cfm $@ CSDPlayer.mf csnd *.class
	jar i $@
	-rm *.class csnd/*
	-rmdir csnd

CsoundEditor.jar: CsoundEditor.java CsoundEditor.mf
	-rm *.class csnd/*
	-rmdir csnd
	javac -classpath ../../bin/csnd.jar $<
	jar xf ../../bin/csnd.jar csnd
	jar cfm $@ CsoundEditor.mf csnd *.class
	jar i $@
	-rm *.class csnd/*
	-rmdir csnd

clean:
	-rm *.jar *.class csnd/*
	-rmdir csnd

=== debian/changelog ===
csound (1:5.12.1~dfsg-6) unstable; urgency=low

  * Acquire lock before using it on chnclear opcode (Closes: #603321)

 -- Felipe Sateler <fsateler@debian.org>  Thu, 16 Dec 2010 20:06:28 -0300

csound (1:5.12.1~dfsg-5) unstable; urgency=medium

  * Do not print error message when RAWwAVE_PATH is undefined
  * Build documentation at install stage to avoid building in buildds.
     Really Closes: #590948
  * Urgency medium to speed up jackd transition.

 -- Felipe Sateler <fsateler@debian.org>  Thu, 05 Aug 2010 12:04:49 -0400

csound (1:5.12.1~dfsg-4) unstable; urgency=medium

  * Build documentation in -doc specific build target, to avoid
    supoerfluous rebuilds in arch-only rebuilds. Closes: bug#590948,
    thanks to Julin Cristau and others.
  * Set urgency=medium to help speed up jackd transition.

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 04 Aug 2010 16:14:22 -0400

csound (1:5.12.1~dfsg-3) unstable; urgency=low

  [ Felipe Sateler ]
  * Disable csound5gui and cseditor
  * Update my e-mail address
  * Remove the DM-Upload-Allowed field
  * Build depend against default-jdk, not default-jdk-builddep, which
    was wrong
  * Do not specify list for java, as it is available on all archs now.

  [ Jonas Smedegaard ]
  * Use Breaks (not Conflicts).
  * Bump Policy compliance to Standards-Version 3.9.1.
  * Comment out cseditor and csound5gui in menu file.

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 01 Aug 2010 16:20:08 -0400

csound (1:5.12.1~dfsg-2) unstable; urgency=low

  * Revert unpatch hack: upsets build daemons.

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 14 Apr 2010 22:36:10 +0200

csound (1:5.12.1~dfsg-1) unstable; urgency=low

  [ Jonas Smedegaard ]
  * Fix Mac-encoded apostrophe in copyright, thanks to lintian.
  * Bump Standards-Version to 3.8.4.
  * Wrap long descriptions at 72 characters.
  * Fix capitalization of PureData in a long description.
  * Packaging moved to Debian Multimedia Maintainers: Update Maintainer
    and Vcs-* stanzas in control file.
  * Drop implementing DEB_MAINTAINER_MODE in rules file: handled in cdbs
    now. Drop related lintian override as well.
  * Drop package-relations.mk (last remaining local CDBS snippet):
    included in cdbs itself now.
  * Use CDBS class python-module.mk, and simplify local Python hacks in
    rules file.
  * Refresh patches, using shortening quilt options --no-timestamps
    --no-index -pab.
  * Update copyright file (new author, no new licenses).
  * Fix use DEB_UPSTREAM_REPACKAGE_EXCLUDES (not abandoned
    DEB_UPSTREAM_REPACKAGE_EXCLUDE) in rules file.
  * Tighten repackaging hints to match current (slightly cleaner)
    upstream release, in rules and copyright files.

  [ Felipe Sateler ]
  * New upstream release
    - Update patches for new upstream release
    - Install crossfm opcode
    - Update symbols file
  * Drop local CDBS snippets that have been integrated in the main CDBS
    package
  * Reorder scons options
  * Reorder build-dependencies
  * Make every build option explicit
  * Fix a segfault when an ending \ is used to split a line in the
    orchestra
  * Do not set buildSDFT option, it was dropped upstream
  * Detect default tcl version and enforce it
  * Enable STK opcodes
  * Invoke the java archs resolution script in debian/rules
  * Update debian/control

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 14 Apr 2010 14:52:43 +0200

csound (1:5.11.1~dfsg-4) unstable; urgency=low

  [ Felipe Sateler ]
  * Change luacsnd package name in control files (this caused -3 luacsnd to be
    empty).
  * Make the lua package provide the old name.
  * Install to /usr/lib/dist-packages with python 2.6 or higher.
    Closes: #571270
  * Add DM-Upload-Allowed field.

  [ Jonas Smedegaard ]
  * Stop mentioning quilt in README.source.
  * Update local CDBS snippets:
    + package-relations.mk:
      - Merge mixture of versioned and unversioned dependencies
      - Use unversioned dependencies when satisfied in oldstable
      - Improve whitespace cleanup
      - Rewrite and silence applying dependencies
      - Handle cdbs 0.4.53 dependency (needed when using debhelper v7)
    + upstream-tarball.mk:
      - Depend unversioned on cdbs (the needed 0.4.39 is in oldstable)
      - Preserve bzip2 tarballs with source format '3.0 (quilt)'.
    + copyright-check.mk:
      - More aggressive scanning (check top 99999 lines, not just 60)
      - Simplify more licensing notices and preserve non-ASCII chars
      - Group hints by sorted owner list (ignoring years)
      - Limit console output both horisontally and vertically
      - Use rev123 of draft DEP5 for hints file
  * Refer to FSF website (not postal address) in debian/rules header.
  * Rewrite copyright file using in DEP5 rev. 135 format.
  * Add DM-Upload-Allowed field to control.in.
  * Refresh patches with quilt option --no-timestamp.
  * Add rudimentary DEP3 patch headers.
  * Build-depend unversioned on cdbs.

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 01 Mar 2010 01:31:25 +0100

csound (1:5.11.1~dfsg-3) unstable; urgency=low

  [ Felipe Sateler ]
  * Be more verbose on mv-inside-for-loops
  * Rename the lua module (Closes: #561131)
  * Do not link against the lua library (Closes: #561128)
  * Rename the lua module as per the lua policy
  * Correct SONAME and package name of the lua bindings
  * Regenerate control file

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 23 Dec 2009 18:51:51 +0100

csound (1:5.11.1~dfsg-2) unstable; urgency=low

  * Fix extend local scons config.py to Include
    /usr/lib/jvm/default-java/include/linux. Thanks to
    Carlos O'Donell for thorough investigations.
  * Switch to source format 3.0 (quilt):
    + Unfuzz patches, and apply them to packaging source.
    + Stop including cdbs snippet patchsys-quilt.mk.
    + Stop build-depending on quilt or patchutils.
    + Add source format hint to packaging source.
  * Drop backportability for Etch:
    + Drop fallback build-dependencies on java-gcj-compat-dev and
      versioned tcl and tk libraries,


=== debian/control ===
Source: csound
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders: Felipe Sateler <fsateler@debian.org>, Jonas Smedegaard <dr@jones.dk>
Build-Depends: cdbs (>= 0.4.73~),
 scons,
 debhelper (>= 6),
 python-central,
 devscripts (>= 2.10.7~),
 dh-buildinfo,
 libsndfile1-dev,
 libasound2-dev [!hurd-i386 !kfreebsd-amd64 !kfreebsd-i386],
 libjack-dev,
 portaudio19-dev,
 libportmidi-dev,
 libpulse-dev,
 swig,
 liblua5.1-0-dev,
 tk-dev,
 tcl-dev,
 python-all-dev (>= 2.3.5-11),
 puredata,
 default-jdk,
 libfltk1.1-dev,
 libfluidsynth-dev,
 liblo-dev,
 fluid,
 ladspa-sdk,
 libboost-dev,
 libboost-serialization-dev,
 libpng12-dev,
 dssi-dev,
 libstk0-dev,
 libgmm++-dev,
 doxygen,
 graphviz,
 ttf-dejavu
Standards-Version: 3.9.1
Vcs-Git: git://git.debian.org/git/pkg-multimedia/csound
Vcs-Browser: http://git.debian.org/?p=pkg-multimedia/csound.git;a=summary
XS-Python-Version: current
Homepage: http://www.csounds.com

Package: csound
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: libcsound64-5.1 (<< 1:5.08.2~dfsg-1)
Recommends: csound-gui, csound-utils, csound-manpages
Description: powerful and versatile sound synthesis software
 Csound is a sound and music synthesis system. Drawing from over 450
 signal processing modules, it can be used to model virtually any
 synthesizer or multi-effect processor. It can work either in real-time
 or as a compiler.
 .
 Csound is to sound synthesis as C is to programming.

Package: csound-gui
Architecture: any
Depends: ${shlibs:Depends}, csound, ${misc:Depends}
Description: GUI interfaces and opcodes for Csound
 This package includes the GUI interfaces for Csound: winsound,
 cseditor and csound5gui, plus the GUI opcodes.
 .
 For more information on Csound, see the csound package.

Package: csound-utils
Architecture: any
Depends: ${shlibs:Depends}, csound, ${misc:Depends}
Description: miscellaneous utilities for the Csound system
 This package contains several utilities which may be useful with
 Csound.
 These utilities aid in score creation, sound analysis and sound 
 transformations.

Package: libcsound64-5.2
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: csound
Breaks: csound (<< 1:5.07.0.dfsg-1)
Description: main library for Csound
 This package contains the library which provides most of the Csound
 functionality. This library was built using 64-bit precision for the
 calculations (this doesn't mean you need a 64-bit processor).
 .
 For more information on Csound, see the csound package.

Package: libcsnd-java
Architecture: any
Section: java
Depends: ${shlibs:Depends}, ${misc:Depends}, default-jre-headless | java2-runtime
Recommends: csound
Suggests: java-virtual-machine
Description: Java bindings for the Csound API
 These are the java bindings for the Csound API.
 .
 For more information on Csound, see the csound package

Package: libcsound64-dev
Architecture: all
Priority: extra
Section: libdevel
Depends: libcsound64-5.2 (>= ${source:Version}), libcsound64-5.2 (<< ${source:Version}.1~), ${misc:Depends}
Description: development files for Csound
 This package contains the development files needed to build programs
 linking to the Csound library.
 .
 For more information on Csound, see the csound package.

Package: libcsnd-dev
Architecture: all
Priority: extra
Section: libdevel
Depends: libcsnd5.2 (>= ${source:Version}), libcsnd5.2 (<< ${source:Version}.1~), ${misc:Depends}
Replaces: libcsnd5.1
Suggests: liblua5.1-luacsnd5.2
Provides: liblua5.1-luacsnd-dev
Description: development files for Csound -- C++ API
 This package contains the development files needed to build programs
 using the C++ bindings to the Csound library. It also includes the
 development symlink for the lua module, but you have to manually
 install liblua5.1-luacsnd5.2 for that to work.
 .
 For more information on Csound, see the csound package.

Package: libcsoundac-dev
Architecture: all
Priority: extra
Section: libdevel
Depends: libcsoundac5.2 (>= ${source:Version}), libcsoundac5.2 (<< ${source:Version}.1~), ${misc:Depends}
Replaces: libcsoundac5.1
Description: development files for CsoundAC
 This package contains the development files needed to build programs
 using the CsoundAC algorithmic composition system.
 .
 For more information on Csound and CsoundAC, see the csound and
 csoundac packages.

Package: pd-csound
Architecture: any
Depends: csound, puredata | pd, ${shlibs:Depends}, ${misc:Depends}
Description: Csound external for PureData
 This is the csoundapi~ opcode for PureData.
 .
 For more information on Csound or pureData, see the respective
 packages.

Package: python-csound
Architecture: any
Section: python
XB-Python-Version: ${python:Versions}
Depends: ${python:Depends}, ${shlibs:Depends}, ${misc:Depends}
Provides: ${python:Provides}
Description: Python bindings for Csound
 This is the Python binding for the Csound API.
 .
 For more information on Csound, see the csound package.

Package: libcsnd5.2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C++ bindings for the Csound API
 This is the C++ binding for the Csound API.
 .
 For more information on Csound, see the csound package.

Package: liblua5.1-luacsnd5.2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Provides: liblua5.1-csnd
Description: Lua bindings for the Csound API
 This is the Lua binding for the Csound API.
 .
 For more information on Csound, see the csound package.

Package: tclcsound
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Tcl bindings and interpreters for Csound
 This package contains the Tcl interfaces to Csound. It includes:
  - tclcsound: the Csound Tcl interface.
  - cswish: Csound wish interpreter
  - cstclsh: Csound Tcl interpreter
 .
 For more information on Csound or Tcl, see the respective packages.

Package: libcsoundac5.2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: the Csound Algorithmic Composition library
 This is the core library for CsoundAC. It provides all the CsoundAC
 functionality. It also contains the development files to create C++
 programs.
 .
 For more information on Csound, see the csound package.

Package: python-csoundac
Architecture: any
Section: python
XB-Python-Version: ${python:Versions}
Depends: ${shlibs:Depends}, ${python:Depends}, python-csound, ${misc:Depends}
Provides: ${python:Provides}
Description: Python bindings for CsoundAC
 This is the Python interface to the Csound Algorithmic Composition
 library.
 .
 For more information on Csound, see the csound package.

Package: csladspa
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Provides: ladspa-plugin
Description: LADSPA plugin for Csound
 This plugin enables the creation of LADSPA plugins with the Csound
 language.
 .
 For more information on Csound or LADSPA, see the csound or ladspa-sdk
 packages, respectively.

Package: libcsound64-doc
Architecture: all
Priority: extra
Section: doc
Depends: ${misc:Depends}
Recommends: csound, libcsound64-dev
Description: Csound API documentation
 This package contains the API documentation for the Csound library in
 PDF format.
 .
 For more information on Csound, see the csound package.

=== debian/rules ===
#!/usr/bin/make -f
# -*- mode: makefile; coding: utf-8 -*-
# Copyright © 2007-2009 Felipe Sateler <fsateler@gmail.com>
# Copyright © 2008-2010 Jonas Smedegaard <dr@jones.dk>
# Description: Main Debian packaging script for CSound
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2, or (at
# your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

DEB_PYTHON_SYSTEM = pycentral
DEB_PYTHON_MODULE_PACKAGES = python-csound python-csoundac
include /usr/share/cdbs/1/rules/upstream-tarball.mk
include /usr/share/cdbs/1/class/scons.mk
include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/python-module.mk
include /usr/share/cdbs/1/rules/utils.mk

DEB_UPSTREAM_URL = http://downloads.sourceforge.net/csound

# Adjustments for unusual upstream tarballs:
# * capitalized project name
# * no dash between project name and version
# * version number included in top folder inside tarball
DEB_UPSTREAM_PACKAGE = Csound
DEB_UPSTREAM_TARBALL_BASENAME_MANGLE = s/\-//g

DEB_UPSTREAM_TARBALL_MD5 = 70b0c4a159c4960a09719674657949c9

# Non-DFSG license: limited to educational and research purposes
DEB_UPSTREAM_REPACKAGE_EXCLUDES = ./Opcodes/scansyn*
# Embedded tarball contains possibly source-less python binary
DEB_UPSTREAM_REPACKAGE_EXCLUDES += ./csound5_osx_installer_files.tar.gz
# Contains explicit copyright but lack licensing info
DEB_UPSTREAM_REPACKAGE_EXCLUDES += ./samples/VintageDreamsWaves-v2.sf2

# Common docs for all packages
DEB_INSTALL_DOCS_ALL = readme-csound5.txt AUTHORS

# Core options of csound
DEB_SCONS_OPTIONS = \
	dynamicCsoundLibrary=1 \
	useDouble=1 \
	buildNewParser=0 \
	NewParserDebug=0 \
	useGettext=1 \
	buildRelease=1 \
	buildUtilities=1 \
	noDebug=0 \
	useLrint=0 \
	Word64=0 \
	Lib64=0 \
	useAltivec=0 \
	withICL=0 \
	withMSVC=0 \
	withSunStudio=0 \
	prefix=/usr \
	generatePdf=0 \
	generateTags=0 \
	bufferoverflowu=0 \
	LINKFLAGS='-Wl,-as-needed' \
	SHLINKFLAGS='-Wl,-as-needed'

# I/O plugins
DEB_SCONS_OPTIONS += \
	useCoreAudio=0 \
	usePortAudio=1 \
	usePortMIDI=1 \
	useJack=1 \
	buildVirtual=1  # Virtual MIDI keyboard
# PulseAudio does not have an option
ifeq "$(DEB_HOST_ARCH_OS)" "linux"
	DEB_SCONS_OPTIONS += useALSA=1
else
	DEB_SCONS_OPTIONS += useALSA=0
endif

# Optional opcodes
DEB_SCONS_OPTIONS += \
	useFLTK=1 \
	noFLTKThreads=1 \
	useOSC=1 \
	buildPythonOpcodes=1 \
	buildDSSI=1 \
	buildLoris=0 \
	useUDP=1 \
	buildStkOpcodes=1 \
	buildvst4cs=0 \
	includeMP3=0 \
	includeWii=0 \
	includeP5Glove=0 \
	buildImageOpcodes=1

# Language Wrappers
# TODO: build for all Python versions (not only current default one)
TCLVERSION := $(shell dpkg -l tcl-dev | sed -n 's/.*\(8\.[45]\)\..*/\1/p')
DEB_SCONS_OPTIONS += \
	buildInterfaces=1 \
	buildJavaWrapper=1 \
	buildPythonWrapper=1 \
	pythonVersion=$(cdbs_python_current_version) \
	buildLuaWrapper=1 \
	buildTclcsound=1 \
	tclversion=$(TCLVERSION) \
	buildPDClass=1

# Frontends
DEB_SCONS_OPTIONS += \
	buildCSEditor=0 \
	buildCsoundAC=1 \
	buildCsoundVST=0 \
	buildCsound5GUI=0 \
	buildOSXGUI=0 \
	buildWinsound=1


# This is a huge optimization boost
ifneq "$(filter amd64 i386, $(DEB_HOST_ARCH_CPU))" ""
	DEB_SCONS_OPTIONS += gcc4opt=generic
endif

# Python >= 2.6 should install to dist-packages instead of site-packages
# Since 2.5 is the only version < 2.6 we support, we test for that.
# TODO: Use simpler second form when 2.6 is default in a stable release
PYLIBPATH = usr/lib/$(cdbs_python_current_binary)/$(if $(call cdbs_streq,$(cdbs_python_current_version),2.5),site-packages,dist-packages)
#PYLIBPATH = usr/lib/$(cdbs_python_current_binary)/dist-packages

CC = $(DEB_HOST_GNU_TYPE)-gcc
CXX = $(DEB_HOST_GNU_TYPE)-g++

# Enable parallel building
ifneq (,$(findstring parallel,$(DEB_BUILD_OPTIONS)))
    PARALLEL_JOBS := $(shell echo $(DEB_BUILD_OPTIONS) | \
        sed -e 's/.*parallel=\([0-9]\+\).*/\1/')
NJOBS := -j$(PARALLEL_JOBS)
endif


DEB_DH_INSTALL_SOURCEDIR = debian/tmp

fltk-orig-files := $(shell find * -type f -name '*.fl')
fltk-autofiles = $(fltk-orig-files:.fl=.cpp) $(fltk-orig-files:.fl=.cxx) $(fltk-orig-files:.fl=.hpp) $(fltk-orig-files:.fl=.h)
swig-autofiles = interfaces/python_interface_wrap.cc interfaces/python_interface_wrap.h
upstreamtmpfiles = custom.py $(fltk-autofiles) $(swig-autofiles) doc/latex/doxygen.sty

common-configure-arch common-configure-indep:: common-configure-impl
common-configure-impl::
	cp --remove-destination debian/custom.py custom.py

DEB_SCONS_BUILD_OPTIONS = $(NJOBS)

DEB_SCONS_INSTALL_OPTIONS = instdir=$(CURDIR)/debian/tmp
DEB_SCONS_INSTALL_TARGET = install=1


install/libcsound64-doc:: build-doxygen-stamp
build-doxygen-stamp:
	doxygen
	touch $@

# Put aside upstream cruft before build but after licensecheck
pre-build:: debian/stamp-upstreamtmpstuff
debian/stamp-upstreamtmpstuff:
	for file in $(upstreamtmpfiles); do \
		[ ! -e $$file ] || [ -e $$file.upstream ] || mv -v $$file $$file.upstream; \
	done
	for dir in $(upstreamtmpdirs); do \
		[ ! -e $$dir ] || [ -e $$dir.upstream ] || mv -v $$dir $$dir.upstream; \
	done
	touch $@

# Revert upstream cruft that was put aside during build
clean::
	for file in $(upstreamtmpfiles); do \
		[ ! -e $$file.upstream ] || mv -v -f $$file.upstream $$file; \
	done
	for dir in $(upstreamtmpdirs); do \
		[ ! -e $$dir.upstream ] || mv -v -f $$dir.upstream $$dir; \
	done
	rm -f debian/stamp-upstreamtmpstuff

clean::
	rm -f build-arch-stamp build-indep-stamp manpages-stamp
# and there still is stuff that doesn't get deleted.
	rm -f interfaces/*.java
	rm -f interfaces/*_interface_wrap.*
	rm -f frontends/CsoundVST/CsoundVST_wrap.h
	rm -f frontends/CsoundAC/CsoundAC_wrap.h
	rm -f lib_CsoundVST.so CsoundVST.py
	rm -f libcsound64.so
	rm -f libcsound64.so.5
	rm -f frontends/cseditor/cseditor.o
	rm -f libcsnd.so
	rm -f CsoundAC.py lib_CsoundAC.so
	rm -f frontends/CsoundAC/*.os
	rm -f libCsoundAC.so*
	rm -rf doc/html
	rm -f csnd.py
# Localisation stuff
	rm -rf po/*/
# fail-missing stuff
	rm -f debian/cdbs-install-diff
	rm -f debian/cdbs-reduced-install-list
	rm -f debian/cdbs-reduced-package-list

install/libcsound64-5.2::
	mkdir -p $(CURDIR)/debian/tmp/usr/share/locale
	cp -r po/*/ $(CURDIR)/debian/tmp/usr/share/locale

# Scons sucks
install/libcsound64-dev::
	ln -sf libcsound64.so.* $(CURDIR)/debian/tmp/usr/lib/libcsound64.so

# avoid conflict with extract
install/csound-utils::
	mv $(CURDIR)/debian/tmp/usr/bin/extract \
		$(CURDIR)/debian/tmp/usr/bin/csound_extract

install/pd-csound::
	mkdir -p $(CURDIR)/debian/tmp/usr/lib/pd/extra
	mv $(CURDIR)/debian/tmp/usr/lib/csoundapi~.pd_linux \
		$(CURDIR)/debian/tmp/usr/lib/pd/extra

install/libcsnd-java::
	mkdir -p $(CURDIR)/debian/tmp/usr/share/java
	mv $(CURDIR)/debian/tmp/usr/lib/csnd.jar \
		$(CURDIR)/debian/tmp/usr/share/java/csnd-$(DEB_UPSTREAM_VERSION).jar
	mkdir -p $(CURDIR)/debian/tmp/usr/lib/jni
	mv $(CURDIR)/debian/tmp/usr/lib/lib_jcsound.so \
		$(CURDIR)/debian/tmp/usr/lib/jni

install/python-csound::
	mkdir -p $(CURDIR)/debian/tmp/$(PYLIBPATH)
	cp csnd.py _csnd.so \
		$(CURDIR)/debian/tmp/$(PYLIBPATH)

install/liblua5.1-luacsnd5.2::
	mkdir -p $(CURDIR)/debian/tmp/usr/lib/lua/5.1/
	install luaCsnd.so $(CURDIR)/debian/tmp/usr/lib/liblua5.1-luacsnd.so.5.2
	ln -s ../../lua5.1-luacsnd.so.5.2 \
	       	$(CURDIR)/debian/tmp/usr/lib/lua/5.1/luaCsnd.so

install/libcsnd-dev::
	ln -s libcsnd.so.5.2 $(CURDIR)/debian/tmp/usr/lib/libcsnd.so
	ln -s liblua5.1-luacsnd.so.5.2 \
		$(CURDIR)/debian/tmp/usr/lib/liblua5.1-csnd.so

install/tclcsound::
# Move the tcl interface to a private dir
